<?php
if (count($_POST) > 0) {
    /* Form Required Field Validation */
    foreach ($_POST as $key => $value) {
        if (empty($_POST[$key])) {
            $message = ucwords($key) . " field is required";
            $type = "error";
            break;
        }
    }
    /* Password Matching Validation */
    if ($_POST['password'] != $_POST['confirm_password']) {
        $message = 'Passwords should be same<br>';
        $type = "error";
    }

    /* Email Validation */
    if (! isset($message)) {
        if (! filter_var($_POST["userEmail"], FILTER_VALIDATE_EMAIL)) {
            $message = "Invalid UserEmail";
            $type = "error";
        }
    }

    /* Validation to check if gender is selected */
    if (! isset($message)) {
        if (! isset($_POST["gender"])) {
            $message = " Gender field is required";
            $type = "error";
        }
    }

    /* Validation to check if Terms and Conditions are accepted */
    if (! isset($message)) {
        if (! isset($_POST["terms"])) {
            $message = "Accept Terms and conditions before submit";
            $type = "error";
        }
    }

    if (! isset($message)) {
        require_once __DIR__ . '/DataSource.php';
        $database = new DataSource();
        $query = "SELECT * FROM registered_users where email = ?";
        $paramType = 's';
        $paramValue = array(
            $_POST["userEmail"]
        );
        $count = $database->getRecordCount($query, $paramType, $paramValue);

        if ($count == 0) {
            $hashedpassword = password_hash(($_POST["password"]), PASSWORD_DEFAULT);
            $query = "INSERT INTO registered_users (user_name, first_name, last_name, password, email, gender) VALUES (?, ?, ?, ?, ?, ?)";
            $paramType = 'ssssss';
            $paramValue = array(
                $_POST["userName"],
                $_POST["firstName"],
                $_POST["lastName"],
                $hashedpassword,
                $_POST["userEmail"],
                $_POST["gender"]
            );

            $current_id = $database->insert($query, $paramType, $paramValue);
            if (! empty($current_id)) {
                $actual_link = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]" . "activate.php?id=" . $current_id;
                $toEmail = $_POST["userEmail"];
                $subject = "User Registration Activation Email";
                $content = "Click this link to activate your account. <a href='" . $actual_link . "'>" . $actual_link . "</a>";
                $mailHeaders = "From: Admin\r\n";
                if (mail($toEmail, $subject, $content, $mailHeaders)) {
                    $message = "You have registered and the activation mail is sent to your email. Click the activation link to activate you account.";
                    $type = "success";
                }
                unset($_POST);
            } else {
                $message = "problem in registration. Try Again!";
            }
        } else {
            $message = "User Email is already in use.";
            $type = "error";
        }
    }
}
?>
<html>
<head>
<title>PHP User Registration Form</title>
<link rel="stylesheet" type="text/css" href="css/style.css" />
<link rel="stylesheet" type="text/css" href="css/form.css" />
<style>
.gender-radio {
    width: auto;
}

#loader-icon {
    margin-left: 80px;
    display: none;
}
</style>
<script>

</script>
</head>
<body>
    <div class="phppot-container">
        <form name="frmRegistration" method="post" action="">
<?php if(isset($message)) { ?>
<div class="message <?php echo $type; ?>"><?php echo $message; ?></div>
<?php } ?>
<h2>User Activation Email</h2>
            <div class="row">
                <label>Username</label> <input type="text"
                    name="userName"
                    value="<?php if(isset($_POST['userName'])) echo $_POST['userName']; ?>">
            </div>
            <div class="row">
                <label> First Name</label> <input type="text"
                    name="firstName"
                    value="<?php if(isset($_POST['firstName'])) echo $_POST['firstName']; ?>">
            </div>
            <div class="row">
                <label>Last Name</label> <input type="text"
                    name="lastName"
                    value="<?php if(isset($_POST['lastName'])) echo $_POST['lastName']; ?>">
            </div>
            <div class="row">
                <label>Password</label> <input type="password"
                    name="password" value="">
            </div>
            <div class="row">
                <label>Confirm Password</label> <input type="password"
                    name="confirm_password" value="">
            </div>
            <div class="row">
                <label>Email</label> <input type="text" name="userEmail"
                    value="<?php if(isset($_POST['userEmail'])) echo $_POST['userEmail']; ?>">
            </div>
            <div class="row">
                <input type="radio" name="gender" value="Male"
                    class="gender-radio"
                    <?php if(isset($_POST['gender']) && $_POST['gender']=="Male") { ?>
                    checked <?php  } ?>> Male<input type="radio"
                    name="gender" value="Female" class="radio-align gender-radio"
                    <?php if(isset($_POST['gender']) && $_POST['gender']=="Female") { ?>
                    checked <?php  } ?>> Female
            </div>
            <div class="row">
                <input type="checkbox" name="terms"> I accept Terms and
                Conditions
            </div>
            <div class="row">
                <input type="submit" name="submit" id="btn-submit"
                    value="Register" onclick="showLoader();">
            </div>
            <div id="loader-icon" class="loader">
                <img src="loader.gif" />
            </div>
        </form>
    </div>
    <script>
    function showLoader() {
        document.getElementById("loader-icon").style.display = 'block';
        document.getElementById("btn-submit").style.display = 'none';
    }
    }
    </script>
</body>
</html>